Index: GTP/trunk/Lib/Vis/OnlineCullingCHC/include/VisibilityEnvironment.h
===================================================================
--- GTP/trunk/Lib/Vis/OnlineCullingCHC/include/VisibilityEnvironment.h	(revision 2278)
+++ GTP/trunk/Lib/Vis/OnlineCullingCHC/include/VisibilityEnvironment.h	(revision 2289)
@@ -23,4 +23,5 @@
 	enum CullingManagerType {COHERENT_HIERARCHICAL_CULLING, 
 							 FRUSTUM_CULLING, 
+							 RANDOM_UPDATE_CULLING,
 							 STOP_AND_WAIT_CULLING, 
 							 NUM_CULLING_MANAGERS};
Index: GTP/trunk/Lib/Vis/OnlineCullingCHC/scripts/terrainCulling.cfg
===================================================================
--- GTP/trunk/Lib/Vis/OnlineCullingCHC/scripts/terrainCulling.cfg	(revision 2256)
+++ GTP/trunk/Lib/Vis/OnlineCullingCHC/scripts/terrainCulling.cfg	(revision 2289)
@@ -3,5 +3,6 @@
 #
 
-OnlineCullingAlgorithm=CHC
+OnlineCullingAlgorithm=RUC
+#OnlineCullingAlgorithm=CHC
 #OnlineCullingAlgorithm=SWC
 #OnlineCullingAlgorithm=VFC
Index: GTP/trunk/Lib/Vis/OnlineCullingCHC/src/StopAndWaitCullingManager.cpp
===================================================================
--- GTP/trunk/Lib/Vis/OnlineCullingCHC/src/StopAndWaitCullingManager.cpp	(revision 2280)
+++ GTP/trunk/Lib/Vis/OnlineCullingCHC/src/StopAndWaitCullingManager.cpp	(revision 2289)
@@ -1,4 +1,4 @@
 #include "StopAndWaitCullingManager.h"
-
+#include "CullingLogManager.h"
 
 namespace GtpVisibility {
@@ -7,4 +7,6 @@
 void StopAndWaitCullingManager::RenderScene()
 {
+	CullingLogManager::GetSingleton()->LogMessage("swc");
+
 	while (!mHierarchyInterface->GetQueue()->empty())
 	{
Index: GTP/trunk/Lib/Vis/OnlineCullingCHC/src/FrustumCullingManager.cpp
===================================================================
--- GTP/trunk/Lib/Vis/OnlineCullingCHC/src/FrustumCullingManager.cpp	(revision 2280)
+++ GTP/trunk/Lib/Vis/OnlineCullingCHC/src/FrustumCullingManager.cpp	(revision 2289)
@@ -1,3 +1,4 @@
 #include "FrustumCullingManager.h"
+#include "CullingLogManager.h"
 
 
@@ -7,6 +8,8 @@
 void FrustumCullingManager::RenderScene()
 {	
+	CullingLogManager::GetSingleton()->LogMessage("vfc");
+
 	while (!mHierarchyInterface->GetQueue()->empty())
-	{;
+	{
 		HierarchyNode *node = mHierarchyInterface->GetQueue()->top();
 		mHierarchyInterface->GetQueue()->pop();
Index: GTP/trunk/Lib/Vis/OnlineCullingCHC/src/CoherentHierarchicalCullingManager.cpp
===================================================================
--- GTP/trunk/Lib/Vis/OnlineCullingCHC/src/CoherentHierarchicalCullingManager.cpp	(revision 2288)
+++ GTP/trunk/Lib/Vis/OnlineCullingCHC/src/CoherentHierarchicalCullingManager.cpp	(revision 2289)
@@ -24,5 +24,5 @@
 void CoherentHierarchicalCullingManager::RenderScene()
 {
-	//CullingLogManager::GetSingleton()->LogMessage("chc");
+	CullingLogManager::GetSingleton()->LogMessage("chc");
 	QueryQueue queryQueue;
 	unsigned int visiblePixels = 0;
Index: GTP/trunk/Lib/Vis/OnlineCullingCHC/src/VisibilityManager.cpp
===================================================================
--- GTP/trunk/Lib/Vis/OnlineCullingCHC/src/VisibilityManager.cpp	(revision 2287)
+++ GTP/trunk/Lib/Vis/OnlineCullingCHC/src/VisibilityManager.cpp	(revision 2289)
@@ -58,5 +58,8 @@
 
 		case VisibilityEnvironment::FRUSTUM_CULLING:
-			//mCullingManager = new FrustumCullingManager();
+			mCullingManager = new FrustumCullingManager();
+			break;
+
+		case VisibilityEnvironment::RANDOM_UPDATE_CULLING:
 			mCullingManager = new RandomUpdateCullingManager();	
 			break;
Index: GTP/trunk/Lib/Vis/OnlineCullingCHC/src/RandomUpdateCullingManager.cpp
===================================================================
--- GTP/trunk/Lib/Vis/OnlineCullingCHC/src/RandomUpdateCullingManager.cpp	(revision 2287)
+++ GTP/trunk/Lib/Vis/OnlineCullingCHC/src/RandomUpdateCullingManager.cpp	(revision 2289)
@@ -29,5 +29,5 @@
 void RandomUpdateCullingManager::RenderScene()
 {
-	//CullingLogManager::GetSingleton()->LogMessage("random");
+	CullingLogManager::GetSingleton()->LogMessage("ruc");
 
 	QueryQueue queryQueue;
Index: GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/src/OgreOcclusionCullingSceneManager.cpp
===================================================================
--- GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/src/OgreOcclusionCullingSceneManager.cpp	(revision 2283)
+++ GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/src/OgreOcclusionCullingSceneManager.cpp	(revision 2289)
@@ -322,4 +322,11 @@
 			 LogManager::getSingleton().logMessage("Using stop and wait algorithm");
 		 }
+		else if (val == "RUC")
+		{
+			 algorithm = 
+				 GtpVisibility::VisibilityEnvironment::RANDOM_UPDATE_CULLING;
+
+			 LogManager::getSingleton().logMessage("Using random update culling");
+		 }
 		 else if (val == "VFC")
 		 {