Index: GTP/trunk/App/Demos/Vis/KdTreeDemo/OGRE/scripts/TestKdTree.vcproj
===================================================================
--- GTP/trunk/App/Demos/Vis/KdTreeDemo/OGRE/scripts/TestKdTree.vcproj	(revision 2279)
+++ GTP/trunk/App/Demos/Vis/KdTreeDemo/OGRE/scripts/TestKdTree.vcproj	(revision 2290)
@@ -264,6 +264,6 @@
 		<Configuration
 			Name="Release Internal|Win32"
-			OutputDirectory="$(ConfigurationName)"
-			IntermediateDirectory="$(ConfigurationName)"
+			OutputDirectory="..\bin\Release"
+			IntermediateDirectory="..\obj\Release"
 			ConfigurationType="1"
 			CharacterSet="2"
@@ -281,5 +281,5 @@
 				OptimizeForWindowsApplication="TRUE"
 				AdditionalIncludeDirectories="..\include;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;..\..\..\..\..\..\Lib\Vis\OnlineCullingCHC\IVReader\include;..\..\..\..\..\..\Lib\Vis\OnlineCullingCHC\OGRE\include;..\..\..\..\..\..\Lib\Vis\OnlineCullingCHC\include"
-				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;GTP_VISIBILITY_MODIFIED_OGRE"
+				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;GTP_VISIBILITY_MODIFIED_OGRE;GAMETOOLS_ILLUMINATION_MODULE"
 				StringPooling="TRUE"
 				MinimalRebuild="TRUE"
@@ -295,9 +295,9 @@
 			<Tool
 				Name="VCLinkerTool"
-				AdditionalDependencies="OgreMain.lib IVReader.lib RTScene.lib RTWorld.lib"
-				OutputFile="$(OutDir)/$(ProjectName).exe"
-				LinkIncremental="1"
-				AdditionalLibraryDirectories="&quot;$(OGRE_PATH)\OgreMain\lib\$(ConfigurationName)&quot;;&quot;..\..\..\..\..\..\Lib\Vis\OnlineCullingCHC\IVReader\lib\$(ConfigurationName)&quot;"
-				GenerateDebugInformation="TRUE"
+				AdditionalDependencies="OgreMain.lib IVReader.lib"
+				OutputFile="$(OutDir)/$(ProjectName).exe"
+				LinkIncremental="1"
+				AdditionalLibraryDirectories="&quot;$(OGRE_PATH)\OgreMain\lib\Release&quot;;..\..\..\..\..\..\Lib\Vis\OnlineCullingCHC\IVReader\lib\Release"
+				GenerateDebugInformation="FALSE"
 				SubSystem="2"
 				OptimizeReferences="2"
Index: GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrain.vcproj
===================================================================
--- GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrain.vcproj	(revision 2279)
+++ GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrain.vcproj	(revision 2290)
@@ -21,5 +21,5 @@
 				Name="VCCLCompilerTool"
 				Optimization="0"
-				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)\Dependencies\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\Dependencies\include\CEGUI&quot;;&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\include&quot;;&quot;$(OGRE_ADDONS_PATH)\dotsceneoctree\PlugIns\DotSceneManager\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\include&quot;;..\..\GtpVisibility\include;..\..\Ogre\include;..\include;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\include;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\OGRE\include;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\IVReader\include"
+				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)\Dependencies\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\Dependencies\include\CEGUI&quot;;&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\include&quot;;..\..\GtpVisibility\include;..\..\Ogre\include;..\include;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\include;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\OGRE\include;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\IVReader\include"
 				PreprocessorDefinitions="_WINDOWS;_STLP_USE_DYNAMIC_LIB;OGRE_LIBRARY_IMPORTS;_DEBUG;WIN32;_STLP_DEBUG;GTP_VISIBILITY_MODIFIED_OGRE;GAMETOOLS_ILLUMINATION_MODULE"
 				MinimalRebuild="TRUE"
@@ -226,6 +226,6 @@
 		<Configuration
 			Name="Release Internal|Win32"
-			OutputDirectory="$(ConfigurationName)"
-			IntermediateDirectory="$(ConfigurationName)"
+			OutputDirectory="..\bin\Release"
+			IntermediateDirectory="..\obj\Release"
 			ConfigurationType="1"
 			CharacterSet="2">
@@ -241,6 +241,6 @@
 				OptimizeForProcessor="3"
 				OptimizeForWindowsApplication="TRUE"
-				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)\Dependencies\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\Dependencies\include\CEGUI&quot;;&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\include&quot;;..\..\Ogre\include;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\include;..\include;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\OGRE\include;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\IVReader\include;&quot;$(LIBXML_HOME)\include&quot;;d:\work\Collada\include"
-				PreprocessorDefinitions="_WINDOWS;_STLP_USE_DYNAMIC_LIB;OGRE_LIBRARY_IMPORTS;_RELEASE;WIN32;_STLP_RELEASE;GTP_VISIBILITY_MODIFIED_OGRE"
+				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)\Dependencies\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\Dependencies\include\CEGUI&quot;;&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\include&quot;;..\..\Ogre\include;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\include;..\include;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\OGRE\include;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\IVReader\include;&quot;$(LIBXML_HOME)\include&quot;;d:\work\Collada\include;..\..\..\..\..\Lib\Vis\Preprocessing\src\Timer"
+				PreprocessorDefinitions="_WINDOWS;_STLP_USE_DYNAMIC_LIB;OGRE_LIBRARY_IMPORTS;_RELEASE;WIN32;_STLP_RELEASE;GTP_VISIBILITY_MODIFIED_OGRE;GAMETOOLS_ILLUMINATION_MODULE"
 				StringPooling="TRUE"
 				RuntimeLibrary="2"
@@ -259,5 +259,5 @@
 				LinkIncremental="1"
 				AdditionalLibraryDirectories="&quot;$(OGRE_PATH)\Dependencies\Lib\Release&quot;;&quot;$(OGRE_PATH)\OgreMain\Lib\Release&quot;;&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\bin\Release&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\lib&quot;;..\..\Ogre\lib\Release;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\lib;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\OGRE\lib\Release;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\IVReader\lib\Release;..\..\..\..\..\..\..\NonGTP\Xerces\xercesc\lib;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\lib\Release;..\..\..\..\..\Lib\Vis\Preprocessing\lib\Release"
-				GenerateDebugInformation="FALSE"
+				GenerateDebugInformation="TRUE"
 				SubSystem="2"
 				OptimizeReferences="2"
Index: GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TerrainFrameListener.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TerrainFrameListener.cpp	(revision 2282)
+++ GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TerrainFrameListener.cpp	(revision 2290)
@@ -17,4 +17,5 @@
 	"Coherent Hierarchical Culling",
 	"View Frustum Culling", 
+	"Random Update Culling", 
 	"Stop and Wait Culling",
 	"Standard Rendering"
@@ -25,5 +26,6 @@
 {
 	"CHC",
-	"VFC", 
+	"VFC",
+	"RUC",
 	"SWC",
 	"DEF"
@@ -288,10 +290,5 @@
 	mTimeFrameEnded = mTimeFrameStarted = mTimer->getMilliseconds();
 	
-	if (0 && (mSceneMgr->getSceneNode("robot Entity1Node")->
-		getAttachedObject(0)->getMovableType() == "Entity"))
-		Ogre::LogManager::getSingleton().logMessage("found entity");
-
 	// init view cell parameters
-	//mSceneMgr->setOption("UseViewCells", &mUseViewCells);
 	mSceneMgr->setOption("UseVisibilityFilter", &mUseVisibilityFilter);
 
@@ -487,6 +484,5 @@
 
 		// important for visualization => draw octree bounding boxes
-		if (0)
-			mSceneMgr->setOption("ShowOctree", &mShowVisualization);
+		if (0) mSceneMgr->setOption("ShowOctree", &mShowVisualization);
 		
 		///////////////
@@ -600,6 +596,4 @@
 													 itemBufferMode);
 
-	//mQueryManager = new PlatformQueryManager(sm->GetHierarchyInterface(),	mWindow->getViewport(0), false);
-
 	visManager->SetQueryManager(mQueryManager);
 
@@ -1255,14 +1249,6 @@
 void TerrainFrameListener::toggleShowViewCells()
 {
-	if (0) // tmp matt
-	{
-		mShowViewCells = !mShowViewCells;
-		mSceneMgr->setOption("ShowViewCells", &mShowViewCells);
-	}
-	else 
-	{
-		unsigned int numObjects;
-		mSceneMgr->getOption("VisibleObjects", &numObjects);
-	}
+	mShowViewCells = !mShowViewCells;
+	mSceneMgr->setOption("ShowViewCells", &mShowViewCells);
 }
 //-----------------------------------------------------------------------
Index: GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrainApplication.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrainApplication.cpp	(revision 2279)
+++ GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrainApplication.cpp	(revision 2290)
@@ -492,13 +492,10 @@
 	
 	// terrain creation
-	if (1)//||msShowHillyTerrain)
-	{
-      	std::string terrain_cfg("terrainCulling.cfg");
-		mSceneMgr->setWorldGeometry(terrain_cfg);
-
-		// was terrain loaded?
-		mSceneMgr->getOption("ShowTerrain", &msShowHillyTerrain); 
-	}
-	
+	std::string terrain_cfg("terrainCulling.cfg");
+	mSceneMgr->setWorldGeometry(terrain_cfg);
+
+	// was terrain loaded?
+	mSceneMgr->getOption("ShowTerrain", &msShowHillyTerrain); 
+		
 	// hack view point for terrain
 	if (msShowHillyTerrain)
@@ -508,5 +505,5 @@
 	}
 
-	////// 
+	
 	//-- CEGUI setup
 	setupGui();
@@ -515,4 +512,5 @@
 	mSceneMgr->setShadowTextureSettings(1024, 2);
 	mSceneMgr->setShadowColour(ColourValue(0.5, 0.5, 0.5));
+
 
 	//////////////
@@ -534,7 +532,7 @@
 	{
 		// the objects are generated randomly distributed over the terrain
-		if (1) generateScene(500, 0); // create robots
-		if (0) generateScene(100, 1); // create trees
-		if (1) generateScene(1000, 2); // create ninjas
+		if (1) generateScene(1500, 0); // create robots
+		if (0) generateScene(100, 1); // create ninjas
+		if (0) generateScene(1000, 2); // create trees
 	}
 }
@@ -627,4 +625,5 @@
 								 this);
 
+	mTerrainFrameListener->setPriority(10);
 	mTerrainFrameListener->setPriority(10);
 	mRoot->addFrameListener(mTerrainFrameListener);