Index: GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/GameTools.program
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/GameTools.program	(revision 2024)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/GameTools.program	(revision 2293)
@@ -48,248 +48,4 @@
 } 
 
-
-
-// Cube mapping programs
-vertex_program GameTools/CubeMap/VertexPrograms/DefaultVS hlsl
-{
-	source GameTools_CubeMap.hlsl
-	entry_point deaultVS
-	target vs_2_0
-} 
-
-fragment_program GameTools/CubeMap/FragmentPrograms/DefaultPS hlsl
-{
-	source GameTools_CubeMap.hlsl
-	entry_point deaultPS
-	target ps_2_0
-
-} 
-
-vertex_program GameTools/Caustic/DefaultVS hlsl
-{
-	source GameTools_Caustic.hlsl
-	entry_point deaultVS
-	target vs_2_0
-} 
-
-fragment_program GameTools/Caustic/DefaultPS hlsl
-{
-	source GameTools_Caustic.hlsl
-	entry_point deaultPS
-	target ps_2_0
-
-} 
-
-vertex_program GameTools/SoftShadow/VertexPrograms/DefaultVS hlsl
-{
-	source GameTools_SoftShadow.hlsl
-	entry_point deaultVS
-	target vs_2_0
-} 
-
-fragment_program GameTools/SoftShadow/FragmentPrograms/DefaultPS hlsl
-{
-	source GameTools_SoftShadow.hlsl
-	entry_point deaultPS
-	target ps_2_0
-
-} 
-
-fragment_program GameTools/SoftShadow/FragmentPrograms/Default2PS hlsl
-{
-	source GameTools_SoftShadow.hlsl
-	entry_point deault2PS
-	target ps_2_0
-
-} 
-
-vertex_program GameTools/CausticSoftShadowVS hlsl
-{
-	source GameTools_CausticSoftShadow.hlsl
-	entry_point deaultVS
-	target vs_2_0
-} 
-
-fragment_program GameTools/CausticSoftShadowPS hlsl
-{
-	source GameTools_CausticSoftShadow.hlsl
-	entry_point deaultPS
-	target ps_2_0
-
-} 
-
-vertex_program GameTools/CubeMap/VertexPrograms/LocalizedVS hlsl
-{
-	source GameTools_Localized_EnvMap.hlsl
-	entry_point LocalizedVS
-	target vs_2_0 
-} 
-
-fragment_program GameTools/CubeMap/FragmentPrograms/LocalizedPS hlsl
-{
-	source GameTools_Localized_EnvMap.hlsl
-	entry_point LocalizedPS
-	target ps_3_0
-}
-
-vertex_program GameTools/CubeMap/VertexPrograms/LocalizedBumpVS hlsl
-{
-	source GameTools_LocalizedBump_EnvMap.hlsl
-	entry_point LocalizedBumpVS
-	target vs_2_0 
-} 
-
-fragment_program GameTools/CubeMap/FragmentPrograms/LocalizedBumpPS hlsl
-{
-	source GameTools_LocalizedBump_EnvMap.hlsl
-	entry_point LocalizedBumpPS
-	target ps_3_0
-}
-
-
-fragment_program GameTools/PhotonMapCausticPS hlsl
-{
-	source GameTools_Localized_EnvMap.hlsl
-	entry_point PhotonMapCausticPS
-	target ps_3_0
-}
-
-//fragment_program GameTools/PhotonMapSoftShadowPS hlsl
-//{
-//	source GameTools_Localized_EnvMap.hlsl
-//	entry_point PhotonMapSoftShadowPS
-//	target ps_3_0
-//}
-
-
- 
-fragment_program GameTools/CubeMap/FragmentPrograms/LocalizedMetalPS hlsl
-{
-	source GameTools_Localized_EnvMap.hlsl
-	entry_point LocalizedMetalPS
-	target ps_3_0
-
-} 
-
-vertex_program GameTools/DistanceVS hlsl
-{
-	source GameTools_Distance.hlsl
-	entry_point DistanceVS
-	target vs_1_1
-} 
-
-fragment_program GameTools/DistancePS hlsl
-{
-	source GameTools_Distance.hlsl
-	entry_point DistancePS
-	target ps_2_0
-
-} 
-
-vertex_program GameTools/ShadowMap/DepthVS hlsl
-{
-	source GameTools_DepthShadow.hlsl
-	entry_point DepthVS
-	target vs_3_0
-} 
-
-fragment_program GameTools/ShadowMap/DepthPS hlsl
-{
-	source GameTools_DepthShadow.hlsl
-	entry_point DepthPS
-	target ps_3_0
-
-}
-
-vertex_program GameTools/ShadowMap/DistVS hlsl
-{
-	source GameTools_DepthShadow.hlsl
-	entry_point DepthDistVS
-	target vs_3_0
-} 
-
-fragment_program GameTools/ShadowMap/DistPS hlsl
-{
-	source GameTools_DepthShadow.hlsl
-	entry_point DepthDistPS
-	target ps_3_0
-
-} 
-
-vertex_program GameTools/ShadowMap/ShadowVS hlsl
-{
-	source GameTools_DepthShadow.hlsl
-	entry_point depthShadowVS
-	target vs_1_1
-} 
-
-fragment_program GameTools/ShadowMap/ShadowPS hlsl
-{
-	source GameTools_DepthShadow.hlsl
-	entry_point depthShadowPS
-	target ps_2_0
-
-} 
-
-vertex_program GameTools/ShadowMap/ShadowDistVS hlsl
-{
-	source GameTools_DepthShadow.hlsl
-	entry_point distShadowVS
-	target vs_1_1
-} 
-
-fragment_program GameTools/ShadowMap/ShadowDistPS hlsl
-{
-	source GameTools_DepthShadow.hlsl
-	entry_point distShadowPS
-	target ps_2_0
-
-} 
-
-vertex_program GameTools/UV_VS hlsl
-{
-	source GameTools_UV.hlsl
-	entry_point UV_VS
-	target vs_2_0
-} 
-
-fragment_program GameTools/UV_PS hlsl
-{
-	source GameTools_UV.hlsl
-	entry_point UV_PS
-	target ps_2_0
-} 
-
-vertex_program GameTools/CauVS hlsl
-{
-	source GameTools_Cau.hlsl
-	entry_point CauVS
-	target vs_3_0
-} 
-
-fragment_program GameTools/CauPS hlsl
-{
-	source GameTools_Cau.hlsl
-	entry_point CauPS
-	target ps_2_0
-
-} 
-
-
-
-vertex_program GameTools/SceneCameraDepthVS hlsl
-{
-	source GameTools_Depth.hlsl
-	entry_point cDepthVS
-	target vs_2_0
-} 
-
-fragment_program GameTools/SceneDepthPS hlsl
-{
-	source GameTools_Depth.hlsl
-	entry_point DepthPS
-	target ps_2_0
-} 
-
 vertex_program GameTools/CubeMap/VertexPrograms/ReduceVS hlsl
 {
@@ -298,26 +54,2 @@
 	target vs_3_0
 } 
-
-fragment_program GameTools/CubeMap/FragmentPrograms/ReducePS hlsl
-{
-	source GameTools_ReduceCubeMap.hlsl
-	entry_point ReduceTexturePS
-	target ps_3_0
-
-} 
-
-
-vertex_program GameTools/DiffuseVS hlsl
-{
-	source GameTools_Localized_EnvMap.hlsl
-	entry_point DiffuseVS
-	target vs_3_0
-} 
-
-fragment_program GameTools/DiffusePS hlsl
-{
-	source GameTools_Localized_EnvMap.hlsl
-	entry_point DiffusePS
-	target ps_3_0
-
-} 