Index: GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TerrainFrameListener.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TerrainFrameListener.cpp	(revision 2290)
+++ GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TerrainFrameListener.cpp	(revision 2305)
@@ -11,4 +11,5 @@
 #include "TestCullingTerrainApplication.h"
 #include <string>
+
 
 //-- captions for overlays
@@ -521,6 +522,5 @@
 		setCurrentFrameInfo(evt.timeSinceLastFrame);
 
-		// HACK for demo: save new frame rates for different methods on the 
-		// same walkthrough
+		// HACK for demo: save new frame rates for the same walkthrough
 		if (mSavePrecomputedFps)
 		{
@@ -758,8 +758,7 @@
 bool TerrainFrameListener::processUnbufferedMouseInput(const FrameEvent& evt)
 {
-	/* Rotation factors, may not be used if the second mouse button is pressed. */
-
-    /* If the second mouse button is pressed, then the mouse movement results in 
-       sliding the camera, otherwise we rotate. */
+	// Rotation factors, may not be used if the second mouse button is pressed.
+    // If the second mouse button is pressed, then the mouse movement results in 
+    // sliding the camera, otherwise we rotate.
     if (mInputDevice->getMouseButton(1))
     {
@@ -1499,5 +1498,9 @@
 		break;
 	case KC_7:
-		mTerrainContentGenerator->WriteObjects(objects_out_filename);
+		{
+			// generate new objects
+			const int numObjects = 500;
+			mApplication->generateScene(numObjects, mCurrentObjectType);
+		}
 		break;
 	case KC_8:
@@ -1550,10 +1553,8 @@
 
 	case KC_F8:
-		{	
-			// generate new objects
-			const int objNum = 500;
-			mApplication->generateScene(objNum, mCurrentObjectType);
-		}
-		break;
+
+		mTerrainContentGenerator->WriteObjects(objects_out_filename);
+		break;
+
 	case KC_F9:
 		mUseAnimation = !mUseAnimation;
Index: GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrainApplication.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrainApplication.cpp	(revision 2290)
+++ GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrainApplication.cpp	(revision 2305)
@@ -173,5 +173,4 @@
 void TestCullingTerrainApplication::loadConfig(const String& filename)
 {
-	// TODO matt
 	// Set up the options
 	ConfigFile config;
@@ -191,64 +190,4 @@
 		 LogManager::getSingleton().logMessage(d.str());
 	}
-
-/*	val = config.getSetting("ViewCells");
-
-	if (!val.empty())
-	{
-		 mViewCellsFilename = val.c_str();
-		 std::stringstream d; d << "view cells file name: " << mViewCellsFilename;
-		 LogManager::getSingleton().logMessage(d.str());
-	}
-
-	mInitialPosition = Vector3::UNIT_SCALE;
-
-	val = config.getSetting("ViewX");
-
-	if (!val.empty())
-		mInitialPosition.x = atof( val.c_str() );
-
-	val = config.getSetting("ViewY");
-	
-	if (!val.empty())
-		mInitialPosition.y = atof(val.c_str());
-
-	val = config.getSetting("ViewZ");
-	
-	if (!val.empty())
-		mInitialPosition.z = atof( val.c_str());
-*/
-
-/*	val = config.getSetting("OnlineCullingAlgorithm");
-
-	if (!val.empty())
-	{
-		 if (val == "CHC")
-		 {
-			 mAlgorithm = 
-				 GtpVisibility::VisibilityEnvironment::COHERENT_HIERARCHICAL_CULLING;
-		 }
-		 else if (val == "SWC")
-		 {
-			 mAlgorithm = 
-				 GtpVisibility::VisibilityEnvironment::STOP_AND_WAIT_CULLING;
-		 }
-		 else if (val == "VFC")
-		 {
-			 mAlgorithm = 
-				 GtpVisibility::VisibilityEnvironment::FRUSTUM_CULLING;
-		 }
-		 else // default rendering
-		 {
-			 mAlgorithm = 
-				 GtpVisibility::VisibilityEnvironment::NUM_CULLING_MANAGERS;
-		 }
-	}
-
-	/////////////
-	// setup scene
-
-	// set camera position accordingly
-	mCamNode->setPosition(mInitialPosition);
-	*/
 }
 //-----------------------------------------------------------------------
@@ -348,5 +287,5 @@
 	if (daeDoc->doImport(daeName))
 	{
-		LogManager::getSingleton().logMessage("yuppi");
+		LogManager::getSingleton().logMessage("loading collada");
 		/**
 		 * build up scene
Index: GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TerrainFrameListener.h
===================================================================
--- GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TerrainFrameListener.h	(revision 2168)
+++ GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TerrainFrameListener.h	(revision 2305)
@@ -42,8 +42,20 @@
 	void Reset()
 	{
-		mAccFps = mBestFps = mWorstFps = mAccTris = mAccQueryCulledNodes = mAccFrustumCulledNodes = mFrameCount = mAccRenderedNodes = 0;
+		mAccFps = 0;
+		mBestFps = 0;
+		mWorstFps = 0;
+		mAccTris = 0;
+		mAccQueryCulledNodes = 0;
+		mAccFrustumCulledNodes = 0;
+		mFrameCount = mAccRenderedNodes = 0;
 	}
 
-	void UpdateFrame(int currentFps, int bestFps, int worstFps, int renderedTris, int renderedNodes, int queryCulledNodes, int frustumCulledNodes)
+	void UpdateFrame(int currentFps, 
+					 int bestFps, 
+					 int worstFps, 
+					 int renderedTris, 
+					 int renderedNodes, 
+					 int queryCulledNodes, 
+					 int frustumCulledNodes)
 	{
 		mAccFps += currentFps;