Index: GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreLightVolumeRenderingRun.cpp
===================================================================
--- GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreLightVolumeRenderingRun.cpp	(revision 2320)
+++ GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreLightVolumeRenderingRun.cpp	(revision 2321)
@@ -257,4 +257,9 @@
 void OgreLightVolumeRenderingRun::freeAllResources()
 {
+	this->lightVolumeTexture = 0;
+	this->lightVolumeTexture2 = 0;
+	this->lightVolumeTextureLast = 0;
+	this->lightVolumeTextureThis = 0;
+	this->lightVolumeTexture3D = 0;
 	TextureManager::getSingleton().remove(name);
 	TextureManager::getSingleton().remove(name + "NoBlur");
Index: GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgrePMWeightComputeRenderingRun.cpp
===================================================================
--- GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgrePMWeightComputeRenderingRun.cpp	(revision 2320)
+++ GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgrePMWeightComputeRenderingRun.cpp	(revision 2321)
@@ -172,4 +172,6 @@
 void OgrePMWeightComputeRenderingRun::freeAllResources()
 {
+	this->weightTexture = 0;
+	this->allWeightsTexture = 0;
 	TextureManager::getSingleton().remove(name);
 	Root::getSingleton()._getCurrentSceneManager()->destroyCamera(name + "_CAMERA");	
Index: GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgrePhaseTextureRenderingRun.cpp
===================================================================
--- GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgrePhaseTextureRenderingRun.cpp	(revision 2320)
+++ GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgrePhaseTextureRenderingRun.cpp	(revision 2321)
@@ -49,4 +49,5 @@
 void OgrePhaseTextureRenderingRun::freeAllResources()
 {
+	this->phaseTexture = 0;
 	TextureManager::getSingleton().remove(name);
 	Root::getSingleton()._getCurrentSceneManager()->destroyCamera(name + "_CAMERA");	
Index: GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgrePhotonMapRenderingRun.cpp
===================================================================
--- GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgrePhotonMapRenderingRun.cpp	(revision 2320)
+++ GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgrePhotonMapRenderingRun.cpp	(revision 2321)
@@ -155,4 +155,5 @@
 void OgrePhotonMapRenderingRun::freeAllResources()
 {
+	this->photonMapTexture = 0;
 	TextureManager::getSingleton().remove(name);
 	Root::getSingleton()._getCurrentSceneManager()->destroyCamera(name + "_CAMERA");	
Index: GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgrePMEntryPointMapRenderingRun.cpp
===================================================================
--- GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgrePMEntryPointMapRenderingRun.cpp	(revision 2320)
+++ GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgrePMEntryPointMapRenderingRun.cpp	(revision 2321)
@@ -88,4 +88,6 @@
 void OgrePMEntryPointMapRenderingRun::freeAllResources()
 {
+	this->entryPointTexture = 0;
+	this->clusterLengthTexture = 0;	
 	TextureManager::getSingleton().remove(name);
 	TextureManager::getSingleton().remove(name + "_CL");	
Index: GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreCausticCubeMapRenderingRun.cpp
===================================================================
--- GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreCausticCubeMapRenderingRun.cpp	(revision 2320)
+++ GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreCausticCubeMapRenderingRun.cpp	(revision 2321)
@@ -100,4 +100,5 @@
 void OgreCausticCubeMapRenderingRun::freeAllResources()
 {
+	this->bluredCausticCubemapTexture = 0;	
 	TextureManager::getSingleton().remove(name);
 	TextureManager::getSingleton().remove(name + "_BLURED");
Index: GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreDepthShadowMapRenderingRun.cpp
===================================================================
--- GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreDepthShadowMapRenderingRun.cpp	(revision 2320)
+++ GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreDepthShadowMapRenderingRun.cpp	(revision 2321)
@@ -393,4 +393,6 @@
 void OgreDepthShadowMapRenderingRun::freeAllResources()
 {
+	this->blurredDepthMapTexture = 0;
+	this->depthMapTexture = 0;
 	TextureManager::getSingleton().remove(name);
 	TextureManager::getSingleton().remove(blurredname);
Index: GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreReducedCubeMapRenderingRun.cpp
===================================================================
--- GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreReducedCubeMapRenderingRun.cpp	(revision 2320)
+++ GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreReducedCubeMapRenderingRun.cpp	(revision 2321)
@@ -108,4 +108,5 @@
 void OgreReducedCubeMapRenderingRun::freeAllResources()
 {
+	this->reducedCubemapTexture = 0;
 	TextureManager::getSingleton().remove(name);
 	Root::getSingleton()._getCurrentSceneManager()->destroyCamera(name + "_CAMERA");	
Index: GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreFocusingMapRenderingRun.cpp
===================================================================
--- GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreFocusingMapRenderingRun.cpp	(revision 2320)
+++ GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreFocusingMapRenderingRun.cpp	(revision 2321)
@@ -126,4 +126,5 @@
 void OgreFocusingMapRenderingRun::freeAllResources()
 {
+	this->focusingTexture = 0;
 	TextureManager::getSingleton().remove(name);
 	Root::getSingleton()._getCurrentSceneManager()->destroyCamera(name + "_CAMERA");	
Index: GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreSceneCameraDepthRenderingRun.cpp
===================================================================
--- GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreSceneCameraDepthRenderingRun.cpp	(revision 2320)
+++ GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreSceneCameraDepthRenderingRun.cpp	(revision 2321)
@@ -67,4 +67,5 @@
 void OgreSceneCameraDepthRenderingRun::freeAllResources()
 {
+	this->depthTexture = 0;
 	TextureManager::getSingleton().remove(name);	
 }
Index: GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreChildParticlesystemRenderingRun.cpp
===================================================================
--- GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreChildParticlesystemRenderingRun.cpp	(revision 2320)
+++ GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreChildParticlesystemRenderingRun.cpp	(revision 2321)
@@ -134,4 +134,5 @@
 void OgreChildPSystemRenderingRun::freeAllResources()
 {
+	impostorTexture = 0;
 	TextureManager::getSingleton().remove(name);
 	Root::getSingleton()._getCurrentSceneManager()->destroyCamera(name + "_CAMERA");	
Index: GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreCubeMapRenderingRun.cpp
===================================================================
--- GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreCubeMapRenderingRun.cpp	(revision 2320)
+++ GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreCubeMapRenderingRun.cpp	(revision 2321)
@@ -246,4 +246,5 @@
 void OgreCubeMapRenderingRun::freeAllResources()
 {
+	this->cubemapTexture = 0;	
 	TextureManager::getSingleton().remove(name);
 	Root::getSingleton()._getCurrentSceneManager()->destroyCamera(name + "_CAMERA");	